=== modified file 'src/README'
--- src/README	2007-12-11 04:24:59 +0000
+++ src/README	2007-12-11 05:40:36 +0000
@@ -24,6 +24,7 @@
         PythonHandler dispatch
         #PythonDebug On
         Options FollowSymLinks
+        PythonOption ivle.handlerpath "/ivle-directory"
     </Directory>
     <Directory "/ivle-directory/media"> 
         SetHandler None

=== added file 'src/dispatch_handler.py'
--- src/dispatch_handler.py	1970-01-01 00:00:00 +0000
+++ src/dispatch_handler.py	2007-12-11 05:40:36 +0000
@@ -0,0 +1,51 @@
+# IVLE
+# Copyright (C) 2007-2008 The University of Melbourne
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+
+# Module: dispatch_handler
+# Author: Matt Giuca
+# Date: 11/12/2007
+
+# This is a mod_python handler program. The correct way to call it is to have
+# Apache send all requests to be handled by the module 'dispatch'.
+
+# This file is a wrapper around the dispatch module, necessary because
+# mod_python does not (for some reason) load the handler directory into
+# sys.path.
+# It requires that the server config has the following line:
+# PythonOption ivle.handlerpath "PATH-TO-IVLE"
+
+# Sets sys.path with the correct path, then calls the handler in the dispatch
+# module.
+
+import sys
+from mod_python import apache
+
+def handler(req):
+    # A nasty hack :(
+    # The 
+
+    try:
+        handlerpath = req.get_options()['ivle.handlerpath']
+        if handlerpath not in sys.path:
+            sys.path.append(handlerpath)
+        import dispatch
+        return dispatch.handler(req)
+    except KeyError:
+        # Note: "Internal Server Error" if "ivle.handlerpath" is not set
+        # (this is valid as it reflects an error in the Apache config
+        # But give useful feedback in debug mode
+        raise Exception("Missing configuration option 'ivle.handlerpath'")

